#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int main (int argc, char*argv[])
{
  int i;
  char op;
  double a, r;
  const double LOG2 = log((double)2);
  /* fattore di conversione per passare da gradi a radianti */
  const double GRA2RAD = (4 * atan((double)1)) / 180;

  /*
  * COMANDI
  *  L = logaritmo in base 10
  *  l = logaritmo in base 2
  *  s o S = seno
  *  c o C = coseno
  *  t o T = tangente
  */

  if (argc < 3)
  {
     fprintf (stderr,"errore: inserire un comando e almeno un angolo\n");
     exit (1);
  }

  if (strlen(argv[1]) != 1)
  {
     fprintf (stderr,"errore: comando non riconosciuto (%s)\n", argv[1]);
     exit (1);
  }

  op = argv[1][0];

  for (i=2; i<argc; i++)
  {
    if (sscanf(argv[i],"%lf",&a)!=1)
    {
      fprintf (stderr, "errore: il parametro '%s' non e' un numero reale\n", argv[i]);
      exit (2);
    }
    switch (op)
    {
    case 'L':
      if (a < 0)
      {
        fprintf (stderr, "errore: impossibile calcolare il logaritmo di %lf\n", a);
        exit (2);
      }
      r = log10 (a);
      break;
    case 'l':
      if (a < 0)
      {
        fprintf (stderr, "errore: impossibile calcolare il logaritmo di %lf\n", a);
        exit (2);
      }
      r = log(a) / LOG2;
      break;
    case 's':
    case 'S':
      r = sin (a * GRA2RAD);
      break;
    case 'c':
    case 'C':
      r = cos (a * GRA2RAD);
      break;
    case 't':
    case 'T':
      r = tan (a * GRA2RAD);
      break;
    default:
      fprintf (stderr, "errore: operazione '%s' sconosciuta\n", argv[2]);
    }
    printf ("%.3lf\n", r);
  }

  return 0;
}
